myproject/Models/ErrorViewModel.cs
namespace myproject.Models;

public class ErrorViewModel
{
    public string? RequestId { get; set; }

    public bool ShowRequestId => !string.IsNullOrEmpty(RequestId);
}

myproject/Controllers/HomeController.cs
using System.Diagnostics;
using Microsoft.AspNetCore.Mvc;
using myproject.Models;

namespace myproject.Controllers;

public class HomeController : Controller
{
    private readonly ILogger<HomeController> _logger;

    public HomeController(ILogger<HomeController> logger)
    {
        _logger = logger;
    }

    public IActionResult Index()
    {
        return View();
    }

    public IActionResult Privacy()
    {
        return View();
    }

    [ResponseCache(Duration = 0, Location = ResponseCacheLocation.None, NoStore = true)]
    public IActionResult Error()
    {
        return View(new ErrorViewModel { RequestId = Activity.Current?.Id ?? HttpContext.TraceIdentifier });
    }


    public IActionResult Plvc()
    {
        return View();
    }



}

myproject/Controllers/PlvcController.cs
using System.Diagnostics;
using Microsoft.AspNetCore.Mvc;
using myproject.Models;

namespace myproject.Controllers;

public class PlvcController : Controller
{
    public IActionResult Index()
    {
        return View(PLVCDatas(""));
    }

    [HttpPost]
    public ActionResult Index(PLVC_Data model)
    {   
        return View(PLVCDatas(model.Name));
    }

    public JsonResult GetData(string name){

        return Json(new {
            Data = PLVCDatas(name)
        });
    }

    public IActionResult Create(){
        return View();
    }

    [HttpPost]
    public IActionResult Create(PLVC_Table model){
        Console.WriteLine("Method: Create || Name: " + model.Name);
        return RedirectToAction("Index");
    }

    public IActionResult Edit(string Id){
        var plvcTable = GetTablePlvc(Id);
        return View(plvcTable);
    }

    [HttpPost]
    public IActionResult Edit(PLVC_Table model){
        Console.WriteLine("Method: Edit || Name: " + model.Name);
        return RedirectToAction("Index");
    }

    public IActionResult Delete(string id){
        Console.WriteLine("Method: Delete || Id: " + id);
        return RedirectToAction("Index");
    }


    [HttpPost]
    public JsonResult Create_Json(PLVC_Table model){
        Console.WriteLine("Method: Create_Json || Name: " + model.Name);
        return Json("Create");
    }

    public IActionResult Edit_Json(string Id){
        var plvcTable = GetTablePlvc(Id);
        return Json(plvcTable);
    }

    [HttpPost]
    public JsonResult Edit_Json(PLVC_Table model){
        Console.WriteLine("Method: Edit_Json || Name: " + model.Name);
        return Json("Edit");
    }


    public PLVC_Data PLVCDatas(string name){
        PLVC_Data data = new PLVC_Data();

        data.Name = "Information";

        data.Tables = new List<PLVC_Table>();
        data.Tables.Add(new PLVC_Table {
            Id = "1",
            Name = "รายการ A",
            Type = "รายการคงเหลือ",
            Amount = 10000,
            Status = "รออนุมัติ"
        });

        data.Tables.Add(new PLVC_Table {
            Id = "2",
            Name = "รายการ B",
            Type = "รายการยอดคงค้าง",
            Amount = 20000,
            Status = "อนุมัติ"
        });

        data.Tables.Add(new PLVC_Table {
            Id = "3",
            Name = "รายการ C",
            Type = "รายการรายจ่าย",
            Amount = 10000,
            Status = "ยกเลิก"
        });

        if(name.ToUpper() == "SEARCH"){
            data.Tables.Add(new PLVC_Table {
                Id = "4",
                Name = "รายการ D",
                Type = "รายการรายจ่าย",
                Amount = 50000,
                Status = "อนุมัติ"
            });
        }

        return data;
    }

    public PLVC_Table GetTablePlvc(string id){
        if(id == "1"){
            return new PLVC_Table
            {
                Id = "1",
                Name = "รายการ A",
                Type = "รายการคงเหลือ",
                Amount = 10000,
                Status = "รออนุมัติ"
            };
        }
        else if(id == "2"){
            return new PLVC_Table
            {
                Id = "2",
                Name = "รายการ B",
                Type = "รายการยอดคงค้าง",
                Amount = 20000,
                Status = "อนุมัติ"
            };
        }
        else{
            return null;
        }
    }

}


public class PLVC_Data{
    public string? Name { get; set; }
    public List<PLVC_Table> Tables { get; set; }
}

public class PLVC_Table{
    public string? Id { get; set; }
    public string? Name { get; set; }
    public string? Type { get; set; }
    public decimal Amount { get; set; }
    public string? Status { get; set; }
}

myproject/Views/Home/Index.cshtml
@{
    ViewData["Title"] = "Home Page";
}

<div class="text-center">
    <h1 class="display-4">Welcome</h1>
    <p>Learn about <a href="https://docs.microsoft.com/aspnet/core">building Web apps with ASP.NET Core</a>.</p>
</div>


<div class="text-center">
    <h1 class="display-4">Welcome PLVC</h1>
    <p>Learn about <a href="www.plvc.ac.th">building Web apps with ASP.NET Core By PLVC</a>.</p>
</div>

myproject/Views/Home/Plvc.cshtml
<h1>Web PLVC</h1>

myproject/Views/Plvc/Create.cshtml
@model myproject.Controllers.PLVC_Table

@{
    ViewData["Title"] = "PLVC Page";
    ViewBag.Titles = "Create";
}

@using (Html.BeginForm("Create", "Plvc", FormMethod.Post))
{
    <div class="row">
        <div class="col-12">
            <span>Id:</span> @Html.TextBoxFor(m => m.Id, new { @class="form-control" })
        </div>
        
        <div class="col-12">
            <span>Name:</span> @Html.TextBoxFor(m => m.Name, new { @class="form-control" })
        </div>
        
        <div class="col-12">
            <span>Type:</span> @Html.TextBoxFor(m => m.Type, new { @class="form-control" })
        </div>
        
        <div class="col-12">
            <span>Amount:</span> @Html.TextBoxFor(m => m.Amount, new { @class="form-control" })
        </div>
        
        <div class="col-12">
            <span>Filter Name:</span> 
            <select id="Status" name="Status" class="form-select">
                <option selected value="อนุมัติ">อนุมัติ</option>
                <option value="รออนุมัติ">รออนุมัติ</option>
                <option value="ยกเลิก">ยกเลิก</option>
            </select>
        </div>
        
        
    </div>
    <input id="Submit" type="submit" value="submit" class="btn btn-primary" />
 
}

myproject/Views/Plvc/Edit.cshtml
@model myproject.Controllers.PLVC_Table

@{
    ViewData["Title"] = "PLVC Page";
    ViewBag.Titles = "Edit";
}

@using (Html.BeginForm("Edit", "Plvc", FormMethod.Post))
{
    <div class="row">
        <div class="col-12">
            <span>Id:</span> @Html.TextBoxFor(m => m.Id, new { @class="form-control" })
        </div>
        
        <div class="col-12">
            <span>Name:</span> @Html.TextBoxFor(m => m.Name, new { @class="form-control" })
        </div>
        
        <div class="col-12">
            <span>Type:</span> @Html.TextBoxFor(m => m.Type, new { @class="form-control" })
        </div>
        
        <div class="col-12">
            <span>Amount:</span> @Html.TextBoxFor(m => m.Amount, new { @class="form-control" })
        </div>
        
        <div class="col-12">
            <span>Filter Name:</span> 
            <select id="Status" name="Status" class="form-select">
                <option selected value="อนุมัติ">อนุมัติ</option>
                <option value="รออนุมัติ">รออนุมัติ</option>
                <option value="ยกเลิก">ยกเลิก</option>
            </select>
        </div>
        
        
    </div>
    <input id="Submit" type="submit" value="submit" class="btn btn-primary" />
 
}

myproject/Views/Plvc/Index.cshtml
@model myproject.Controllers.PLVC_Data

@{
    ViewData["Title"] = "PLVC Page";
    ViewBag.Titles = "PLVC Page 2";
}

@using (Html.BeginForm("Index", "Plvc", FormMethod.Post))
{
    <div class="row">
        <div class="col-12">
            <span>Filter Name:</span> @Html.TextBoxFor(m => m.Name, new { @class="form-control" })
            <input id="Submit" type="submit" value="submit" class="btn btn-primary" />
        </div>
    </div>
 
}

@Html.ActionLink("Create", "Create", "Plvc", new { @class="btn btn-primary" })

<h1>@Model.Name By Form</h1>

<table class="table table-bordered">
  <thead>
    <tr>
      <th class="text-center">#</th>
      <th class="text-center">Name</th>
      <th class="text-center">Type</th>
      <th class="text-center">Amount</th>
      <th class="text-center">Status</th>
      <th class="text-center">Action</th>
    </tr>
  </thead>
  <tbody>
    @foreach (var item in Model.Tables)
    {
        <tr>
            <th class="text-center">@item.Id</th>
            <td>@item.Name</td>
            <td class="text-center">@item.Type</td>
            <td class="text-end">@item.Amount.ToString("#,##0.00")</td>
            <td class="text-center">
                @if(item.Status == "อนุมัติ"){
                    <span class="badge bg-primary">@item.Status</span>
                }
                else if(item.Status == "รออนุมัติ")
                {
                    <span class="badge bg-warning text-dark">@item.Status</span>
                }
                else
                {
                    <span class="badge bg-danger">@item.Status</span>
                }
            </td>
            <td class="text-center">
                <a href="/plvc/Edit?Id=@item.Id" class="btn btn-warning">Edit</a>
                <a href="/plvc/Delete?Id=@item.Id" class="btn btn-danger">Delete</a>
            </td>
        </tr>
    }
  </tbody>
</table>

<hr />

<h1>@Model.Name By Javascript</h1>

<div class="row">
    <div class="col-12">
        <span>Filter Name:</span> <input type="text" id="txtName" />
        <input id="btnSearch" type="button" value="Search" class="btn btn-primary" />
    </div>
</div>

    <!-- Button trigger modal -->
<button type="button" class="btn btn-primary" data-bs-toggle="modal" data-bs-target="#staticCreateBackdrop">
  Create
</button>

<table class="table table-bordered">
  <thead>
    <tr>
      <th class="text-center">#</th>
      <th class="text-center">Name</th>
      <th class="text-center">Type</th>
      <th class="text-center">Amount</th>
      <th class="text-center">Status</th>
      <th class="text-center">Action</th>
    </tr>
  </thead>
  <tbody id="jsBody"></tbody>
</table>




<!-- Modal -->
<div class="modal fade" id="staticCreateBackdrop" data-bs-backdrop="static" data-bs-keyboard="false" tabindex="-1" aria-labelledby="staticCreateBackdropLabel" aria-hidden="true">
  <div class="modal-dialog">
    <div class="modal-content">
      <div class="modal-header">
        <h5 class="modal-title" id="staticCreateBackdropLabel">Create</h5>
        <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
      </div>
      <div class="modal-body">
        <div class="row">
            <div class="col-12">
                <span>Id: </span>
                <input type="text" id="staticCreateId" class="form-control" />
            </div>
            <div class="col-12">
                <span>Name: </span>
                <input type="text" id="staticCreateName" class="form-control" />
            </div>
        </div>
      </div>
      <div class="modal-footer">
        <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Close</button>
        <button type="button" id="staticCreateSubmit" class="btn btn-primary">Understood</button>
      </div>
    </div>
  </div>
</div>

<button type="button" id="btnModalEdit" class="btn btn-primary" data-bs-toggle="modal" data-bs-target="#staticEditBackdrop" style="display:none; ">
  Edit
</button>

<!-- Modal -->
<div class="modal fade" id="staticEditBackdrop" data-bs-backdrop="static" data-bs-keyboard="false" tabindex="-1" aria-labelledby="staticEditBackdropLabel" aria-hidden="true">
  <div class="modal-dialog">
    <div class="modal-content">
      <div class="modal-header">
        <h5 class="modal-title" id="staticEditBackdropLabel">Edit</h5>
        <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
      </div>
      <div class="modal-body">
        <div class="row">
            <div class="col-12">
                <span>Id: </span>
                <input type="text" id="staticEditId" class="form-control" />
            </div>
            <div class="col-12">
                <span>Name: </span>
                <input type="text" id="staticEditName" class="form-control" />
            </div>
        </div>
      </div>
      <div class="modal-footer">
        <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Close</button>
        <button type="button" id="staticEditSubmit" class="btn btn-primary">Understood</button>
      </div>
    </div>
  </div>
</div>


@section Scripts{
    <script type="text/javascript">
        $(document).ready(function () {
            console.log('ready.');

            RenderTables('Information');
        });

        $('#staticCreateSubmit').click(async function () {
            console.log('staticCreateSubmit.');

            const rawResponse = await fetch('/plvc/Create_Json', {
                method: 'POST',
                body: JSON.stringify({
                        Id: $('#staticCreateId').val(), 
                        Name: $('#staticCreateName').val()
                    })
            });
            const content = await rawResponse.json();

            console.log('staticCreateSubmit: ', content);

        });

        async function OnEdit(id){
            $('#btnModalEdit').click();

            const rawResponse = await fetch('/plvc/Edit_Json?Id=' + id, {
                method: 'GET',
            });

            const content = await rawResponse.json();

            console.log('btnModalEdit: ', content);

            $('#staticEditId').val(content.id);
            $('#staticEditName').val(content.name);
        }

        $('#staticEditSubmit').click(async function () {
            console.log('staticEditSubmit.');

            const rawResponse = await fetch('/plvc/Edit_Json', {
                method: 'POST',
                body: JSON.stringify({
                        Id: $('#staticEditId').val(), 
                        Name: $('#staticEditName').val()
                    })
            });
            const content = await rawResponse.json();

            console.log('staticEditSubmit: ', content);

        });

        async function OnDelete(id){

            const rawResponse = await fetch('/plvc/Delete?Id=' + id, {
                method: 'GET',
            });

            console.log('OnDelete: ', rawResponse);

            window.location.reload();

        }

        $('#btnSearch').click(function () {
            var name = $('#txtName').val();

            console.log('btnSearch: ', name);
            
            RenderTables(name);
        });

        async function RenderTables(filter){
            console.log('RenderTables.');

            var url = 'plvc/GetData?name=' + filter;

            let res = await fetch(url, {
                method: 'GET'
            });

            var result = await res.json();

            console.log('result: ', result);

            $('#jsBody').html('');

            result.data.tables.forEach(function (item, index){
                $('#jsBody').append(Const_RenderTables(item.id, item.name, item.type, item.amount, item.status));
            });

        }

        function Const_RenderTables(id, name, type, amount, status){
            var statusTxt = '';
            if(status == "อนุมัติ"){
                statusTxt = `<span class="badge bg-primary">${status}</span>`
            }
            else if(status == "รออนุมัติ")
            {
                statusTxt = `<span class="badge bg-warning text-dark">${status}</span>`
            }
            else
            {
                statusTxt = `<span class="badge bg-danger">${status}</span>`
            }

            return `
<tr>
    <th class="text-center">${id}</th>
    <td>${name}</td>
    <td class="text-center">${type}</td>
    <td class="text-end">${amount.toFixed(2)}</td>
    <td class="text-center">${statusTxt}</td>
    <td class="text-center">
        <button class="btn btn-warning" onClick="OnEdit(${id})">Edit</button>
        <button class="btn btn-danger" onClick="OnDelete(${id})">Delete</button>
    </td>
</tr>            
            `
        }
    </script>
}

myproject/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"] (@ViewBag.Titles) - myproject</title>
    <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.min.css" />
    <link rel="stylesheet" href="~/css/site.css" asp-append-version="true" />
    <link rel="stylesheet" href="~/myproject.styles.css" asp-append-version="true" />
</head>
<body>
    <header>
        <nav class="navbar navbar-expand-sm navbar-toggleable-sm navbar-light bg-white border-bottom box-shadow mb-3">
            <div class="container-fluid">
                <a class="navbar-brand" asp-area="" asp-controller="Home" asp-action="Index">myproject</a>
                <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target=".navbar-collapse" aria-controls="navbarSupportedContent"
                        aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="navbar-collapse collapse d-sm-inline-flex justify-content-between">
                    <ul class="navbar-nav flex-grow-1">
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Home" asp-action="Index">Home</a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Plvc" asp-action="Index">Plvc Page</a>
                        </li>
                    </ul>
                </div>
            </div>
        </nav>
    </header>
    <div class="container">
        <main role="main" class="pb-3">
            @RenderBody()
        </main>
    </div>

    <footer class="border-top footer text-muted">
        <div class="container">
            &copy; 2023 - myproject - <a asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
        </div>
    </footer>
    <script src="~/lib/jquery/dist/jquery.min.js"></script>
    <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
    <script src="~/js/site.js" asp-append-version="true"></script>
    @await RenderSectionAsync("Scripts", required: false)
</body>
</html>